/*!
 * @file glgui_style.h
 * @brief Definition of ...
*/

#ifndef _GLGUI_STYLE_H
#define _GLGUI_STYLE_H

// FORWARD DECLARATION

#include "font.h"
#include "texture.h"
#include "color.h"

namespace OrxGui
{

  //! A class for Defining Styles to the opengl-gui.
  class GLGuiStyle
  {
    //! An enumerator that defines the different states Widgets may be in.
    typedef enum {
      Normal,           //!< Normal state of the GUI's Widgets.
      Active,           //!< If the widget is Active.
      Selected,         //!< If the Widget is Selected.
      Insensitive       //!< If the Widget is insensitive.
    } State;

  public:
    GLGuiStyle();
    virtual ~GLGuiStyle();


  private:

    float             _borderLeft;
    float             _borderRight;
    float             _borderTop;
    float             _borderBottom;

    Font*             _font;
    float             _textSize;
    float             _textColor;

    float             _backgroundColor;
    Texture           _backgorundTexture;

    float             _foregroundColor;
    Texture           _foregorundTexture;

    bool              _animated;
    bool              _animatedStateChanges;
  };
}
#endif /* _GLGUI_STYLE_H */
